<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Click & Give - Web</title>

    <style media="screen">
      body { background: #ECEFF1; color: rgba(0,0,0,0.87); font-family: Roboto, Helvetica, Arial, sans-serif; margin: 0; padding: 0; }
      #emailVerified, #resetPassword, #loading { background: white; max-width: 360px; margin: 100px auto 16px; padding: 32px 24px; border-radius: 3px; }
      h2 { color: #F73750; font-weight: bold; font-size: 16px; margin: 0 0 8px; }
      h1 { font-size: 22px; font-weight: 300; color: rgba(0,0,0,0.6); margin: 0 0 16px;}
      p { line-height: 140%; margin: 16px 0 24px; font-size: 14px; }
      input { border: solid 1px #AAA;width: 90%; display: block; margin-bottom: 10px; margin-top: 10px; text-align: center; text-decoration: none; color: black; padding: 16px; border-radius: 4px;}
      button { border: none; width: 100%; display: block; text-align: center; font-size: 22; background: #F73750; text-transform: uppercase; text-decoration: none; color: white; padding: 16px; border-radius: 4px; }
      button { box-shadow: 0 1px 3px rgba(0,0,0,0.12), 0 1px 2px rgba(0,0,0,0.24); }
      img { filter: invert(40%) sepia(47%) saturate(5862%) hue-rotate(332deg) brightness(104%) contrast(109%) }
      #load { color: rgba(0,0,0,0.4); text-align: center; font-size: 13px; }
      @media (max-width: 600px) {
        body, #message { margin-top: 0; background: white; box-shadow: none; }
        body { border-top: 16px solid #ffa100; }
      }
    </style>
  </head>
  <body>
    <div id="emailVerified" style="display: none">
      <div id="emailVerifiedSuccess">
        <h2>Congrats !</h2>
        <h1>Your email has been verified</h1>
        <p>Now you can log in Click & Give mobile application.</p>
      </div>
      <div id="emailVerifiedError" style="display:none">
        <h2>Error</h2>
        <h1>Your email hasn't been verified</h1>
        <p>This error may occur because your code is expired. Please repeat the process.</p>
      </div>
    </div>
    <div id="resetPassword" style="display: none">
      <div id="resetPasswordInput">
        <h2>Password reset</h2>
        <h1>Your can edit your password below :</h1>
        <input id="newPassword" name="newPassword" value="" placeholder="Enter the New Password" type="password">
        <p id="minPasswordLength" style="font-style: italic; color: #F73750; display: none">Your password must be at least 6 characters long.</p>
        <button onclick="updatePassword()" >Change password</button>
      </div>
      <div id="resetPasswordSuccess" style="display:none">
        <h2>Congrats</h2>
        <h1>Your password has been updated</h1>
        <p>Now you can log in Click & Give mobile application.</p>
      </div>
      <div id="resetPasswordError" style="display:none">
        <h2>Error</h2>
        <h1>Your password hasn't been updated</h1>
        <p>Your code may be expired. Please repeat the process.</p>
      </div>
    </div>
    <div id="loading">
      <h2>Loading</h2>
      <h1>Checking your informations</h1>
      <div style="text-align: center">
        <img src="oval.svg" width="25" alt="">
      </div>
    </div>

    <script src="https://www.gstatic.com/firebasejs/8.0.1/firebase.js"></script>
    <script>
      // Get the action to complete.
      var mode = getParameterByName('mode');
      //console.log(mode);

      var apiKey = getParameterByName('apiKey');
      // Get the one-time code from the query parameter.
      var actionCode = getParameterByName('oobCode');
      // (Optional) Get the continue URL from the query parameter if available.
      var continueUrl = getParameterByName('continueUrl');
      // (Optional) Get the language code if available.
      var lang = getParameterByName('lang') || 'en';

      // Configure the Firebase SDK.
      var config = {
        'apiKey': apiKey
      };
      var app = firebase.initializeApp(config);
      var auth = app.auth();

      document.addEventListener('DOMContentLoaded', function() {

        // Handle the user management action.
        switch (mode) {
          case 'resetPassword':
          // Display reset password handler and UI.
          handleResetPassword(auth, actionCode, continueUrl, lang);
          break;
          case 'verifyEmail':
          // Display email verification handler and UI.
          handleVerifyEmail(auth, actionCode, continueUrl, lang);
          break;
          default:
          // Error: invalid mode.
        }
      }, false);

            function handleResetPassword(auth, actionCode, continueUrl, lang) {
              const loading = document.querySelector('#loading');
              const resetPassword = document.querySelector('#resetPassword');
              const resetPasswordError = document.querySelector('#resetPasswordError');
              const resetPasswordInput = document.querySelector('#resetPasswordInput');

              auth.verifyPasswordResetCode(actionCode).then(function(email) {

              resetPassword.style.display = 'block';
              loading.style.display = 'none';
              var accountEmail = email;

              // TODO: Show the reset screen with the user's email and ask the user for
              // the new password.
              resetPassword.style.display = 'block';
              loading.style.display = 'none';


            }).catch(function(error) {
              // Invalid or expired action code. Ask user to try to reset the password
              // again.
              loading.style.display = 'none';
              resetPasswordError.style.display = 'block';
              resetPasswordInput.style.display = 'none';
              resetPassword.style.display = 'block';
              //console.log("Invalid or expired action code : " + error);
            });
            };

            function handleVerifyEmail(auth, actionCode, continueUrl, lang) {
              const loading = document.querySelector('#loading');
              const emailVerified = document.querySelector('#emailVerified');
              const emailVerifiedSuccess = document.querySelector('#emailVerifiedSuccess');
              const emailVerifiedError = document.querySelector('#emailVerifiedError');

              auth.applyActionCode(actionCode).then(function(resp) {
                // Email address has been verified.
                emailVerified.style.display = 'block';
                loading.style.display = 'none';
              }).catch(function(error) {
                //Error occured
                loading.style.display = 'none';
                emailVerified.style.display = 'block';
                emailVerifiedSuccess.style.display = 'none';
                emailVerifiedError.style.display = 'block';
                //console.log("Email verification error : " + error);
              });
            };

            function updatePassword (){
              const loading = document.querySelector('#loading');
              const resetPassword = document.querySelector('#resetPassword');
              const resetPasswordError = document.querySelector('#resetPasswordError');
              const resetPasswordInput = document.querySelector('#resetPasswordInput');
              const minPasswordLength = document.querySelector('#minPasswordLength');
              var actionCode = getParameterByName('oobCode');

              var newPasswordList = document.getElementsByName('newPassword');
              var newPassword = newPasswordList[0].value;

              if(newPassword.length < 6){
                minPasswordLength.style.display = "block";
              } else {
                // Save the new password.
                minPasswordLength.style.display = "none";
                loading.style.display = "block";
                resetPassword.style.display = "none";

                auth.confirmPasswordReset(actionCode, newPassword).then(function(resp) {
                  // Password reset has been confirmed and new password updated.
                  loading.style.display = "none";
                  resetPassword.style.display = "block";
                  resetPasswordInput.style.display = "none";
                  resetPasswordSuccess.style.display = "block";

                }).catch(function(error) {
                  // Error occurred during confirmation. The code might have expired or the
                  // password is too weak.
                  loading.style.display = "none";
                  resetPassword.style.display = "block";
                  resetPasswordError.style.display = 'block';
                  resetPasswordInput.style.display = 'none';
                  //console.log("Password too weak : " + error);
                });
              }

            }

            function getParameterByName( name ){
              name = name.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");
              var regexS = "[\\?&]"+name+"=([^&#]*)";
              var regex = new RegExp( regexS );
              var results = regex.exec( window.location.href );
              if( results == null )
                return "";
              else
                return decodeURIComponent(results[1].replace(/\+/g, " "));
            };
    </script>
  </body>
</html>
